%define is_mandrake %(test -e /etc/mandrake-release && echo 1 || echo 0)
%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define is_fedora %(test -e /etc/fedora-release && echo 1 || echo 0)

%define dist redhat
%define disttag rh

%if %is_mandrake
%define dist mandrake
%define disttag mdk
%endif
%if %is_suse
%define dist suse
%define disttag suse
%endif
%if %is_fedora
%define dist fedora
%define disttag rhfc
%endif

%define distver %(release="`rpm -q --queryformat='%{VERSION}' %{dist}-release 2>/dev/null`" ; if test $? != 0 ; then release="" ; fi ; echo "$release")

Summary: A console homebanking programme using HBCI
Name: aqmoney2
Version: 1.9.3
Release: 1.%{disttag}%{distver}
Source: http://download.sourceforge.net/aqmoney/%{name}-%{version}.tar.gz
BuildRequires: openhbci2-devel >= 1.9.2 ktoblzcheck
Group: Applications/Internet
License: GPL
Packager: Martin Preuss <martin@libchipcard.de>
URL: http://aqmoney.sourceforge.net
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: /sbin/ldconfig

%description
AqMoney2 is a free command line homebanking application using HBCI.
HBCI (Home Banking Computer Interface) is the German 
homebanking standard used by many German banks. 
AqMoney2 is the reference application for the OpenHBCI library.

%package devel
Summary: Header files and static library for libaqmoney
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the header files and static library
of libaqmoney.

%prep
%setup -q

%build
%configure
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-,root,root,0755)
%doc AUTHORS README LIESMICH COPYING ChangeLog TODO
%{_bindir}/aqmoney2
%{_datadir}/aqmoney
%{_libdir}/libaqmoney.so.*
%{_mandir}/man1/aqmoney2.1*
%{_mandir}/man5/aqmoney-*

%files devel
%defattr(-,root,root,0755)
%doc src/libaqmoney/doc/FILEHIERARCHY src/libaqmoney/doc/files/TRANSACTIONS
%doc src/libaqmoney/doc/files/DEBITNOTES src/libaqmoney/doc/files/TRANSFERS
%{_libdir}/libaqmoney.a
%{_libdir}/libaqmoney.la
%{_libdir}/libaqmoney.so
%{_includedir}/aqmoney2/*.h

%changelog
