# $Id: ktoblzcheck.m4,v 1.6 2004/02/09 20:50:17 rbla Exp $
# (c) 2002 Martin Preuss<martin@libchipcard.de>
# This function checks if KTOBLZCHECK is wanted and locates it

AC_DEFUN(AQ_CHECK_KTOBLZCHECK,[
dnl PREREQUISITES:
dnl   none
dnl IN: 
dnl   nothing
dnl OUT:
dnl   Variables:
dnl     ktoblzcheck_libraries: Path to the KTOBLZCHECK libraries (subst)
dnl     ktoblzcheck_lib: KTOBLZCHECK libraries to link against (subst)
dnl     ktoblzcheck_includes: Path to the KTOBLZCHECK includes (subst)
dnl     ktoblzcheck_datafile: Path to ktoblzcheck data file
dnl     ktoblzcheck_available: "yes" if KTOBLZCHECK is available
dnl   Defines:

dnl check if ktoblzcheck is desired
AC_MSG_CHECKING(if KTOBLZCHECK should be used)
AC_ARG_ENABLE(ktoblzcheck,AC_HELP_STRING([--enable-ktoblzcheck],
                                         [enable ktoblzcheck support [default=yes]]),
  enable_ktoblzcheck="$enableval",
  enable_ktoblzcheck="yes")
AC_MSG_RESULT($enable_ktoblzcheck)

if test "$enable_ktoblzcheck" != "no"; then

dnl ******* ktoblzcheck includes ***********
AC_MSG_CHECKING(for ktoblzcheck includes)
AC_ARG_WITH(ktoblzcheck-includes,AC_HELP_STRING([--with-ktoblzcheck-includes=DIR],
                                                [adds ktoblzcheck include path]),
  [ktoblzcheck_search_inc_dirs="$withval"],
  [ktoblzcheck_search_inc_dirs="$prefix/include /usr/local/include /usr/include"])

dnl search for ktoblzcheck
AQ_SEARCH_FOR_PATH([ktoblzcheck.h],[$ktoblzcheck_search_inc_dirs])
if test -z "$found_dir" ; then
  AC_MSG_RESULT(not found)
else
  ktoblzcheck_includes="-I$found_dir"
  AC_MSG_RESULT($ktoblzcheck_includes)
fi


dnl ******* ktoblzcheck lib ***********
AC_MSG_CHECKING(for ktoblzcheck lib)
AC_ARG_WITH(ktoblzcheck-libname,AC_HELP_STRING([--with-ktoblzcheck-libname=NAME],
                                               [specify the name of the ktoblzcheck library]),
  [ktoblzcheck_search_lib_names="$withval"],
  [ktoblzcheck_search_lib_names="libktoblzcheck.so \
	                 libktoblzcheck.so.* \
	                 libktoblzcheck.a"])

AC_ARG_WITH(ktoblzcheck-libs,AC_HELP_STRING([--with-ktoblzcheck-libs=DIR],
                                            [adds ktoblzcheck library path]),
  [ktoblzcheck_search_lib_dirs="$withval"],
  [ktoblzcheck_search_lib_dirs="$prefix/lib /usr/local/lib \
		       /usr/lib \
		       /lib"])

dnl search for ktoblzcheck libs
for d in $ktoblzcheck_search_lib_dirs; do
  AQ_SEARCH_FILES("$d",$ktoblzcheck_search_lib_names)
  if test -n "$found_file" ; then
     ktoblzcheck_libraries="-L$d"
     ktoblzcheck_lib="-l`echo $found_file | sed 's/lib//;s/\.so*//;s/\.a//'`"
     break
  fi
done


if test -z "$ktoblzcheck_libraries" -o -z "$ktoblzcheck_lib" -o -z "$ktoblzcheck_includes"; then
    ktoblzcheck_available="no"
    AC_MSG_RESULT(not found)
else
    ktoblzcheck_available="yes"
    AC_MSG_RESULT($ktoblzcheck_libraries ${ktoblzcheck_lib})
fi


dnl ******* ktoblzcheck datafile ***********
AC_MSG_CHECKING(for ktoblzcheck datafile)
AC_ARG_WITH(ktoblzcheck-datafile,AC_HELP_STRING([--with-ktoblzcheck-datafile=FILE],
                                                [uses the given file]),
  [ktoblzcheck_datafile="$withval"],
  [ktoblzcheck_search_data_dirs="$prefix/share/ktoblzcheck \
    /usr/local/share/ktoblzcheck \
    /usr/share/ktoblzcheck"])

dnl search for ktoblzcheck data file
for f in $ktoblzcheck_datafile $ktoblzcheck_search_data_dirs/bankdata.txt; do
  if test -r $f; then
    ktoblzcheck_datafile=$f
    break
  fi
  ktoblzcheck_datafile=""
done

if test -z $ktoblzcheck_datafile; then
  AC_MSG_RESULT(not found)
else
  AC_MSG_RESULT($ktoblzcheck_datafile)
fi


# end of "if enable-ktoblzcheck"
fi
AC_SUBST(ktoblzcheck_includes)
AC_SUBST(ktoblzcheck_libraries)
AC_SUBST(ktoblzcheck_lib)
AC_SUBST(ktoblzcheck_datafile)
])

