/***************************************************************************
 $RCSfile: aqmconverter.cpp,v $
                             -------------------
    cvs         : $Id: aqmconverter.cpp,v 1.2 2004/01/25 18:51:24 aquamaniac Exp $
    begin       : Sat May 17 2003
    copyright   : (C) 2003 by Martin Preuss
    email       : martin@aquamaniac.de
*/

/***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "aqmconverter.h"
#include <assert.h>


AQMConverter::AQMConverter(){
  _transactions=GWEN_DB_Group_new("transactions");
}



AQMConverter::~AQMConverter(){
  GWEN_DB_Group_free(_transactions);
}


void AQMConverter::clear(){
  GWEN_DB_ClearGroup(_transactions, 0);
}



Error AQMConverter::readFromStream(GWEN_BUFFEREDIO *bio){
  return Error("AQMConverter::readFromStream",
               ERROR_LEVEL_NORMAL,
               HBCI_ERROR_CODE_UNSUPPORTED,
               ERROR_ADVISE_DONTKNOW,
               "method not supported");
}



Error AQMConverter::writeToStream(GWEN_BUFFEREDIO *bio){
  return Error("AQMConverter::writeToStream",
               ERROR_LEVEL_NORMAL,
               HBCI_ERROR_CODE_UNSUPPORTED,
               ERROR_ADVISE_DONTKNOW,
               "method not supported");
}



void AQMConverter::addTransaction(GWEN_DB_NODE *xa){
  GWEN_DB_NODE *n;

  assert(_transactions);
  assert(xa);
  n=GWEN_DB_GetGroup(_transactions, GWEN_PATH_FLAGS_CREATE_GROUP,
                     "transaction");
  assert(n);
  GWEN_DB_AddGroupChildren(n, xa);
}


void AQMConverter::addTransactions(GWEN_DB_NODE *xa){
  GWEN_DB_NODE *nn;
  GWEN_DB_NODE *cn;

  assert(_transactions);
  assert(xa);
  nn=GWEN_DB_GetFirstGroup(xa);
  while(nn) {
    if (strcasecmp(GWEN_DB_GroupName(nn), "transaction") ||
        strcasecmp(GWEN_DB_GroupName(nn), "transfer"))
      cn=GWEN_DB_GetGroup(_transactions, GWEN_PATH_FLAGS_CREATE_GROUP,
                          "transaction");
    else if (strcasecmp(GWEN_DB_GroupName(nn), "debit_note"))
      cn=GWEN_DB_GetGroup(_transactions, GWEN_PATH_FLAGS_CREATE_GROUP,
                          "debit_note");
    else
      cn=0;

    if (!cn) {
      DBG_INFO(0, "Unknown section \"%s\", ignoring",
               GWEN_DB_GroupName(nn));
    }
    else {
      GWEN_DB_AddGroupChildren(cn, nn);
    }
    nn=GWEN_DB_GetNextGroup(nn);
  } // while
}





void AQMConverter::setTransactions(GWEN_DB_NODE *xa, bool take){
  assert(xa);
  GWEN_DB_Group_free(_transactions);
  if (take)
    _transactions=xa;
  else
    _transactions=GWEN_DB_Group_dup(xa);
}



GWEN_DB_NODE *AQMConverter::transactions(){
  return _transactions;
}









