/***************************************************************************
  $RCSfile: aqmmodule.h,v $
  -------------------
  cvs         : $Id: aqmmodule.h,v 1.5 2004/01/25 18:51:25 aquamaniac Exp $
  begin       : Tue Oct 14 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/


#ifndef AQMONEY_MODULE_H
#define AQMONEY_MODULE_H


#include <aqmoney2/aqmapi.h>

#include <stdio.h>
#include <string>
#include <openhbci2.h>

using namespace std;
using namespace HBCI;


typedef enum {
  ModuleErrorSuccess=0,
  ModuleErrorArguments,
  ModuleErrorLoad,
  ModuleErrorSave,
  ModuleErrorInvalidArgs,
  ModuleErrorInconsistentSystem,
  ModuleErrorExecution,
  ModuleErrorReadingfile,
  ModuleErrorWritingfile,
  ModuleErrorSequence

} ModuleError;


/**
 *
 */
class AqmoneyModule {
private:
public:
  /**
   *
   */
  AqmoneyModule();
  virtual ~AqmoneyModule();
  virtual string name() const=0;
  /**
   * Dumps a description. This is called when showing a usage screen.
   * This method should insert 3 blanks at the beginning of each line.
   */
  virtual void dumpDescription(FILE *f)=0;
  virtual void usage()=0;
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile)=0;

};




#endif


