/***************************************************************************
  $RCSfile: bankmanager.h,v $
  -------------------
  cvs         : $Id: bankmanager.h,v 1.3 2004/01/25 18:51:25 aquamaniac Exp $
  begin       : Wed Oct 22 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/


#ifndef AQMONEY_BANKMANAGER_H
#define AQMONEY_BANKMANAGER_H

#include <string>

#ifdef USE_KTOBLZCHECK
# include <ktoblzcheck.h>
#endif

#include <openhbci2/error.h>

using namespace std;
using namespace HBCI;


typedef enum {
  BankManagerCheckResultUnknown=0,
  BankManagerCheckResultOk,
  BankManagerCheckResultFailed,
  BankManagerCheckResultBankUnknown
} BANKMANAGER_CHECKRESULT;


class BankManager {
public:
  /**
   *
   */
  class BankInfo {
  private:
    unsigned int _country;
    string _bankCode;
    string _bankName;
    string _bankLocation;
    // more to come
  public:
    BankInfo();
    BankInfo(unsigned int country,
             const string &code,
             const string &name,
             const string &location);
    ~BankInfo();
    unsigned int country() const { return _country;};
    const string &code() const { return _bankCode;};
    const string &name() const { return _bankName;};
    const string &location() const { return _bankLocation;};

  };
private:
#ifdef USE_KTOBLZCHECK
  AccountNumberCheck _checker;
#endif

public:
  BankManager(const string &datafile);
  ~BankManager();

  BANKMANAGER_CHECKRESULT checkAccount(unsigned int country,
                                       const string &bankCode,
                                       const string &accountId);
  BankInfo getBankInfo(unsigned int country,
                       const string &bankCode) throw(Error);

};



#endif


