/***************************************************************************
  $RCSfile: converterbin.h,v $
  -------------------
  cvs         : $Id: converterbin.h,v 1.4 2004/01/25 18:51:29 aquamaniac Exp $
  begin       : Fri Oct 24 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_CONVERTER_BIN_H
#define AQMONEY_CONVERTER_BIN_H

#include <aqmoney2/aqmconverter.h>
#include <aqmoney2/aqmapi.h>


/**
 *
 */
class AQMConverterBin: public AQMConverter {
private:
  AqMoneyAPI *_api;
  string _name;
  string _subtype;
public:
  AQMConverterBin(AqMoneyAPI *api,
                  const string &name,
                  const string &subtype="");

  /*
   * Please note that after destryoing this object all pointers returned by
   * @ref transactions() become invalid !
   */
  virtual ~AQMConverterBin();

  /**
   * Reads a stream until the end of stream is reached and translates the
   * input data to a list of transactions.
   */
  virtual Error readFromStream(GWEN_BUFFEREDIO *bio);

  /**
   * Writes the internal list of transactions to the given stream using
   * this classes own format
   */
  virtual Error writeToStream(GWEN_BUFFEREDIO *bio);

};




#endif

