/***************************************************************************
  $RCSfile: convertercsv.cpp,v $
  -------------------
  cvs         : $Id: convertercsv.cpp,v 1.3 2004/01/25 18:51:29 aquamaniac Exp $
  begin       : Wed Oct 22 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "convertercsv.h"
#include <gwenhywfar/csv.h>
#include <assert.h>



AQMConverterCSV::AQMConverterCSV(const string &cfgFile)
:AQMConverter()
,_cfgFile(cfgFile){

}


AQMConverterCSV::~AQMConverterCSV(){
}



Error AQMConverterCSV::readFromStream(GWEN_BUFFEREDIO *bio){
  return Error("AQMConverterCSV::readFromStream",
               ERROR_LEVEL_NORMAL,
               HBCI_ERROR_CODE_UNSUPPORTED,
               ERROR_ADVISE_DONTKNOW,
               "not yet supported");
}



Error AQMConverterCSV::writeToStream(GWEN_BUFFEREDIO *bio){
  GWEN_DB_NODE *cfg;
  GWEN_DB_NODE *data;

  cfg=GWEN_DB_Group_new("cfg");
  /* read configuration file */
  if (GWEN_DB_ReadFile(cfg,
                       _cfgFile.c_str(),
                       GWEN_DB_FLAGS_DEFAULT |
                       GWEN_PATH_FLAGS_CREATE_GROUP)) {
    GWEN_DB_Group_free(cfg);
    return Error("AQMConverterCSV::writeToStream",
                 ERROR_LEVEL_NORMAL,
                 HBCI_ERROR_CODE_INVALID,
                 ERROR_ADVISE_DONTKNOW,
                 "error reading config file",
                 _cfgFile);
  }
  data=transactions();
  if (GWEN_CSV_Write(bio, cfg, data)) {
    GWEN_DB_Group_free(cfg);
    return Error("AQMConverterCSV::writeToStream",
                 ERROR_LEVEL_NORMAL,
                 HBCI_ERROR_CODE_INVALID,
                 ERROR_ADVISE_DONTKNOW,
                 "error writing CSV stream",
                 _cfgFile);
  }

  GWEN_DB_Group_free(cfg);
  return Error();
}








