/***************************************************************************
  $RCSfile: convertercsv.h,v $
  -------------------
  cvs         : $Id: convertercsv.h,v 1.5 2004/02/15 22:34:56 rbla Exp $
  begin       : Wed Oct 22 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_CONVERTER_CSV_H
#define AQMONEY_CONVERTER_CSV_H

#include <aqmoney2/aqmconverter.h>
#include <string>
using namespace std;



/**
 *
 */
class AQMConverterCSV: public AQMConverter {
private:
  string _cfgFile;

public:
  AQMConverterCSV(const string &cfgfile=AQMDATADIR"/csv.conf");

  /*
   * Please note that after destryoing this object all pointers returned by
   * @ref transactions() become invalid !
   */
  virtual ~AQMConverterCSV();

  /**
   * Reads a stream until the end of stream is reached and translates the
   * input data to a list of transactions.
   */
  virtual Error readFromStream(GWEN_BUFFEREDIO *bio);

  /**
   * Writes the internal list of transactions to the given stream using
   * this classes own format
   */
  virtual Error writeToStream(GWEN_BUFFEREDIO *bio);

};




#endif

