/***************************************************************************
  $RCSfile: converterdb.cpp,v $
  -------------------
  cvs         : $Id: converterdb.cpp,v 1.2 2004/01/25 18:51:29 aquamaniac Exp $
  begin       : Wed Oct 22 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "converterdb.h"
#include <assert.h>



AQMConverterDB::AQMConverterDB(): AQMConverter(){
}


AQMConverterDB::~AQMConverterDB(){
}



Error AQMConverterDB::readFromStream(GWEN_BUFFEREDIO *bio){
  GWEN_DB_NODE *n;

  n=GWEN_DB_Group_new("transactions");
  assert(n);
  if (GWEN_DB_ReadFromStream(n, bio,
                             GWEN_DB_FLAGS_DEFAULT |
                             GWEN_PATH_FLAGS_CREATE_GROUP)) {
    return Error("AQMConverterDB::readFromStream",
                 ERROR_LEVEL_NORMAL,
                 HBCI_ERROR_CODE_INVALID,
                 ERROR_ADVISE_DONTKNOW,
                 "error in input stream");
  }
  setTransactions(n, true);
  return Error();
}



Error AQMConverterDB::writeToStream(GWEN_BUFFEREDIO *bio){
  if (GWEN_DB_WriteToStream(transactions(), bio, GWEN_DB_FLAGS_DEFAULT)) {
    return Error("AQMConverterDB::writeToStream",
                 ERROR_LEVEL_NORMAL,
                 HBCI_ERROR_CODE_INVALID,
                 ERROR_ADVISE_DONTKNOW,
                 "error in output stream");
  }
  return Error();
}








