/***************************************************************************
  $RCSfile: loganalyzer.h,v $
  -------------------
  cvs         : $Id: loganalyzer.h,v 1.5 2004/01/25 18:51:25 aquamaniac Exp $
  begin       : Sat Oct 25 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_LOGANALYZER_H
#define AQMONEY_LOGANALYZER_H

#include <aqmoney2/aqmapi.h>
#include <gwenhywfar/db.h>

#include <list>
#include <string>
using namespace std;


/**
 *
 */
class LogAnalyzer {
public:
  class LogFile {
  public:
    class LogMessage {
    public:
    private:
      GWEN_DB_NODE *_header;
      string _message;
    public:
      LogMessage(GWEN_DB_NODE *header, const string &body);
      ~LogMessage();
      GWEN_DB_NODE *header() { return _header;};
      const string &message() const { return _message;};
    };

  private:
    list<Pointer<LogMessage> > _logMessages;
  public:
    LogFile(const string &file);
    ~LogFile();
    list<Pointer<LogMessage> > logMessages() { return _logMessages;};
  };

private:
  AqMoneyAPI *_api;
  unsigned int _country;
  string _bankCode;
  list<string> _logFiles;
  list<string>::iterator _lfit;

  string _getPath();
  static void *_handlePathElement(const char *entry,
                                  void *data,
                                  unsigned int flags);

public:
  LogAnalyzer(AqMoneyAPI *api,
              unsigned int country,
              const string &bank);
  ~LogAnalyzer();

  Pointer<LogFile> getFirstLogFile();
  Pointer<LogFile> getNextLogFile();

};



#endif


