/***************************************************************************
  $RCSfile: convert.h,v $
  -------------------
  cvs         : $Id: convert.h,v 1.5 2004/01/26 08:04:06 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_CONVERT_H
#define AQMONEY_CONVERT_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleConvert: public AqmoneyModule {
private:
  struct s_args {
    string intype;       // -it
    string inparam;      // -ip
    string outtype;      // -ot
    string outparam;     // -op
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

public:
  ModuleConvert();
  virtual ~ModuleConvert();
  virtual string name() const { return "convert";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


