/***************************************************************************
  $RCSfile: createkeys.h,v $
  -------------------
  cvs         : $Id: createkeys.h,v 1.5 2004/01/26 08:04:06 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_CREATEKEYS_H
#define AQMONEY_CREATEKEYS_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleCreateKeys: public AqmoneyModule {
private:
  struct s_args {
    int country;
    string bankCode;
    string customerId;
    bool activate;
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

public:
  ModuleCreateKeys();
  virtual ~ModuleCreateKeys();
  virtual string name() const { return "createkeys";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


