/***************************************************************************
  $RCSfile: createuser.h,v $
  -------------------
  cvs         : $Id: createuser.h,v 1.5 2004/01/26 08:04:06 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_CREATEUSER_H
#define AQMONEY_CREATEUSER_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleCreateUser: public AqmoneyModule {
private:
  struct s_args {
    int country;
    string bankCode;
    string user;
    string customer;
    string mediumtype;
    string mediumname;
    string server;
    bool import;
    bool readonly;
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();
  bool _checkMedium(AqMoneyAPI *api,
                    bool isFile,
                    string &mediumName,
                    string &mediumTypeName);
  Error _reallyCreateUser(AqMoneyAPI *api,
                          const string &mediumname,
                          const string &mediumType,
                          bool readonly,
                          int country,
                          const string &instid,
                          const string &userid,
                          const string &customerid,
                          const string &server);
  Error _importUser(AqMoneyAPI *api,
                    string mediumname,
                    const string &mtype,
                    bool readonly,
                    int country,
                    const string &instid,
                    const string &userid,
                    const string &customerid,
                    const string &server);

public:
  ModuleCreateUser();
  virtual ~ModuleCreateUser();
  virtual string name() const { return "createuser";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


