/***************************************************************************
  $RCSfile: debitnote.h,v $
  -------------------
  cvs         : $Id: debitnote.h,v 1.7 2004/01/26 08:04:06 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_DEBITNOTE_H
#define AQMONEY_DEBITNOTE_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleDebitNote: public AqmoneyModule {
private:
  struct s_args {
    int country;              // -c
    string bankCode;          // -b
    string accountId;         // -a
    string accountSubId;      // -as
    int otherCountry;         // -oc
    string otherBankCode;     // -ob
    string otherAccount;      // -oa
    Value val;                // -v
    Date date;                // -d
    int textKey;              // -k
    list<string> otherName;   // -on
    list<string> purpose;     // -p
    bool skipBad;             // -skip-bad
    string badFile;           // -bf
    string goodFile;          // -gf
    string notDoneFile;       // -nf
    string tfiletype;         // -t
    string tfileparam;        // -tp
    list<string> tfiles;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();
  bool _checkAccount(AqMoneyAPI *api, GWEN_DB_NODE *n);
  bool _checkAccount(AqMoneyAPI *api,
                     unsigned int country,
                     const string &bankCode,
                     const string &accountid);
  GWEN_DB_NODE *_makeTransaction(Pointer<Customer> c,
                                 Pointer<Account> acc,
                                 int otherCountry,
                                 const string &otherBankCode,
                                 const string &otherAccount,
                                 const list<string> &otherName,
                                 const list<string> &purpose,
                                 const Value &val,
                                 int textKey,
                                 const Date &date,
                                 const string &id);
  Error _checkTransaction(GWEN_DB_NODE *xa,
                          GWEN_DB_NODE *params);

public:
  ModuleDebitNote();
  virtual ~ModuleDebitNote();
  virtual string name() const { return "debitnote";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


