/***************************************************************************
  $RCSfile: delsto.h,v $
  -------------------
  cvs         : $Id: delsto.h,v 1.4 2004/01/25 18:51:57 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_DELSTO_H
#define AQMONEY_DELSTO_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleDeleteStandingOrder: public AqmoneyModule {
private:
  struct s_args {
    int country;              // -c
    string bankCode;          // -b
    string accountId;         // -a
    int otherCountry;         // -oc
    string otherBankCode;     // -ob
    string otherAccount;      // -oa
    Value val;                // -v
    int textKey;              // -k
    list<string> otherName;   // -on
    list<string> purpose;     // -p
    Date date;                // -d
    Date firstDate;           // -fd
    Date lastDate;            // -ld
    bool weekly;              // -w
    int turnus;               // -tu
    int day;                  // -dy
    string jobId;             // -j
    bool skipBad;             // -skip-bad
    string badFile;           // -bf
    string goodFile;          // -gf
    string notDoneFile;       // -nf
    string tfiletype;         // -t
    string tfileparam;        // -tp
    list<string> tfiles;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();
  bool _checkAccount(AqMoneyAPI *api, GWEN_DB_NODE *n);
  bool _checkAccount(AqMoneyAPI *api,
                     unsigned int country,
                     const string &bankCode,
                     const string &accountid);
  GWEN_DB_NODE *_makeTransaction(Pointer<Customer> c,
                                 Pointer<Account> acc);
public:
  ModuleDeleteStandingOrder();
  virtual ~ModuleDeleteStandingOrder();
  virtual string name() const { return "delsto";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


