/***************************************************************************
  $RCSfile: dump.h,v $
  -------------------
  cvs         : $Id: dump.h,v 1.6 2004/01/25 18:52:00 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_DUMP_H
#define AQMONEY_DUMP_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


#define AQM_DUMP_FLAGS_TRANSACTIONS   0x00010000
#define AQM_DUMP_FLAGS_BALANCE        0x00020000
#define AQM_DUMP_FLAGS_USERS          0x00040000
#define AQM_DUMP_FLAGS_ACCOUNT_HEADER 0x00080000
#define AQM_DUMP_FLAGS_STANDINGORDERS 0x00100000
#define AQM_DUMP_FLAGS_DATEDXFERS     0x00200000
#define AQM_DUMP_FLAGS_NOTEDXFERS     0x00400000

#define AQM_DUMP_FLAGS_DEFAULT \
  AQM_DUMP_FLAGS_ACCOUNT_HEADER | \
  AQM_TRANSACTION_MATCH_DEFAULT


/**
 *
 */
class ModuleDump: public AqmoneyModule {
private:
  struct s_args {
    int country;              // -c
    string bankCode;          // -b
    string accountId;         // -a
    string userId;            // -u
    Date fromDate;            // -f
    Date toDate;              // -t
    string otherAccount;      // -oa
    string otherBankCode;     // -ob
    int otherCountry;         // -oc
    unsigned int flags;
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

  int _dumpAccountRelated(AqMoneyAPI *api);

  bool _xactionToEntry(GWEN_DB_NODE *n,
                       string *e,
                       int &height);
  string _dumpXactionTXT(GWEN_DB_NODE *n);
  string _dumpXactionsTXT(Pointer<Account> acc);

  bool _stoToEntry(GWEN_DB_NODE *n,
                   string *e,
                   int &height);
  string _dumpStandingOrderTXT(GWEN_DB_NODE *n);
  string _dumpStandingOrdersTXT(Pointer<Account> acc);

  string _dumpDatedTransfersTXT(Pointer<Account> acc);
  string _dumpNotedTransfersTXT(Pointer<Account> acc);

  string _dumpBalanceTXT(Pointer<Account> acc);
  string _dumpUserTXT(Pointer<User> u);
  string _dumpUsersTXT(AqMoneyAPI *api);
  int _dumpUsers(AqMoneyAPI *api);

  string _condensedString(const string &s);
  string _breakString(const string &s, unsigned int brk);
  string _indentString(const string &s, unsigned int ins);


public:
  ModuleDump();
  virtual ~ModuleDump();
  virtual string name() const { return "dump";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


