/***************************************************************************
  $RCSfile: gettransactions.h,v $
  -------------------
  cvs         : $Id: gettransactions.h,v 1.4 2004/01/25 18:52:02 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_GETTRANSACTIONS_H
#define AQMONEY_GETTRANSACTIONS_H

#include "aqmmodule.h"
#include <openhbci2/date.h>

#include <list>
#include <string>

using namespace std;
using namespace HBCI;


/**
 *
 */
class ModuleGetTransactions: public AqmoneyModule {
private:
  struct s_args {
    int country;
    string bankCode;
    string accountId;
    Date fromDate;
    Date toDate;
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

public:
  ModuleGetTransactions();
  virtual ~ModuleGetTransactions();
  virtual string name() const { return "turnover";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


