/***************************************************************************
  $RCSfile: iniletter.h,v $
  -------------------
  cvs         : $Id: iniletter.h,v 1.4 2004/03/24 21:13:24 rbla Exp $
  begin       : Wed Dec 17 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/


#ifndef AQMONEY_INILETTER_H
#define AQMONEY_INILETTER_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleIniLetter: public AqmoneyModule {
private:
  struct s_args {
    int country;
    string bankCode;
    string customerId;
    string keyType;
    string outputType;
    string outputFile;
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

  string dumpHexString(string s);
  string dumpHexStringPS(string s, int *x, int *y, int offset);
  string makeTxtLetter(string hash,
                       string modulus,
                       string exponent,
                       int keyversion,
                       int keynumber,
                       string userid,
                       string sysid,
                       bool user,
                       bool usecrypt);
  string makePSLetter(string hash,
                      string modulus,
                      string exponent,
                      int keyversion,
                      int keynumber,
                      string userid,
                      string sysid,
                      bool user,
                      bool usecrypt);

public:
  ModuleIniLetter();
  virtual ~ModuleIniLetter();
  virtual string name() const { return "iniletter";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};





#endif /* AQMONEY_INILETTER_H */


