/***************************************************************************
  $RCSfile: texport.h,v $
  -------------------
  cvs         : $Id: texport.h,v 1.7 2004/01/25 18:52:19 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_TEXPORT_H
#define AQMONEY_TEXPORT_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleExport: public AqmoneyModule {
private:
  typedef enum {
    ExportTypeTransactions=0,
    ExportTypeTransfers,
    ExportTypeDatedTransfers,
    ExportTypeStandingOrders,
    ExportTypeNotedTransfers,
  } EXPORT_TYPE;
  struct s_args {
    int country;              // -c
    string bankCode;          // -b
    string accountId;         // -a
    string userId;            // -u
    Date fromDate;            // -f
    Date toDate;              // -t
    string otherAccount;      // -oa
    string otherBankCode;     // -ob
    int otherCountry;         // -oc
    string outfile;           // -o
    string outtype;           // -ot
    string outparam;          // -op
    unsigned int flags;
    EXPORT_TYPE exportType;   // -et
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

  ModuleError _exportTransactions(AqMoneyAPI *api, EXPORT_TYPE et);

public:
  ModuleExport();
  virtual ~ModuleExport();
  virtual string name() const { return "texport";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


