/***************************************************************************
  $RCSfile: update.h,v $
  -------------------
  cvs         : $Id: update.h,v 1.4 2004/01/25 18:52:20 aquamaniac Exp $
  begin       : Wed Oct 15 2003
  copyright   : (C) 2003 by Martin Preuss
  email       : martin@libchipcard.de

 ***************************************************************************
 *    Please see the file COPYING in top source dir for licence details    *
 ***************************************************************************/

#ifndef AQMONEY_UPDATE_H
#define AQMONEY_UPDATE_H

#include "aqmmodule.h"
#include <list>
#include <string>

using namespace std;


/**
 *
 */
class ModuleUpdate: public AqmoneyModule {
private:
  struct s_args {
    int country;
    string bankCode;
    string customerId;
    list<string> params;
  };
  s_args _args;

  int _checkArgs(s_args &args, int argc, char **argv);
  void _usage();

public:
  ModuleUpdate();
  virtual ~ModuleUpdate();
  virtual string name() const { return "update";};
  virtual void dumpDescription(FILE *f);
  virtual ModuleError run(AqMoneyAPI *api,
                          int argc, char **argv,
                          const string &openhbciFile,
                          const string &aqmoneyFile);
  virtual void usage() { return _usage(); };

};



#endif


