

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "loganalyzer.h"
#include <gwenhywfar/text.h>




int main(int argc, char **argv) {
  string file;
  Pointer<AqMoneyAPI> api;
  Pointer<LogAnalyzer> ana;
  Pointer<LogAnalyzer::LogFile> lf;
  list<Pointer<LogAnalyzer::LogFile::LogMessage> > lmsgs;
  list<Pointer<LogAnalyzer::LogFile::LogMessage> >::iterator lmit;

  api=new AqMoneyAPI(true);
  if (GWEN_Logger_Open(0,
                       "aqmoney2",
                       "qtest.log",
                       GWEN_LoggerTypeConsole,
                       GWEN_LoggerFacilityUser)) {
    fprintf(stderr,"Could not start logging, aborting.\n");
    return 2;
  }
  GWEN_Logger_SetLevel(0, GWEN_LoggerLevelInfo);

  ana=new LogAnalyzer(api.ptr(), 280, "99950002");
  lf=ana.ref().getFirstLogFile();
  lmsgs=lf.ref().logMessages();
  for (lmit=lmsgs.begin(); lmit!=lmsgs.end(); lmit++) {
    fprintf(stderr, "Message:\n");
    GWEN_DB_Dump((*lmit).ref().header(), stderr, 1);
    GWEN_Text_DumpString((*lmit).ref().message().c_str(),
                         (*lmit).ref().message().length(),
                         stderr, 1);
  }
  return 0;
}
